git@vger.kernel.org mailing list mirror (one of many)
 help / color / mirror / code / Atom feed
* [PATCH] filter-branch: skip commits present on --state-branch
@ 2018-06-23  4:36 Michael Barabanov
  2018-06-25 22:14 ` Junio C Hamano
  2018-06-26  4:07 ` [PATCH v2] " Michael Barabanov
  0 siblings, 2 replies; 5+ messages in thread
From: Michael Barabanov @ 2018-06-23  4:36 UTC (permalink / raw)
  To: gitster; +Cc: git, ijc, Michael Barabanov

The commits in state:filter.map have already been processed, so don't
filter them again. This makes incremental git filter-branch much faster.

Also add tests for --state-branch option.

Signed-off-by: Michael Barabanov <michael.barabanov@gmail.com>
---
 git-filter-branch.sh     |  3 +++
 t/t7003-filter-branch.sh | 15 +++++++++++++++
 2 files changed, 18 insertions(+)

diff --git a/git-filter-branch.sh b/git-filter-branch.sh
index ccceaf19a..2df7ed107 100755
--- a/git-filter-branch.sh
+++ b/git-filter-branch.sh
@@ -372,6 +372,9 @@ while read commit parents; do
 	git_filter_branch__commit_count=$(($git_filter_branch__commit_count+1))
 
 	report_progress
+	if test -r "$workdir/../map/$commit"; then
+		continue
+	fi
 
 	case "$filter_subdir" in
 	"")
diff --git a/t/t7003-filter-branch.sh b/t/t7003-filter-branch.sh
index ec4b160dd..e23de7d0b 100755
--- a/t/t7003-filter-branch.sh
+++ b/t/t7003-filter-branch.sh
@@ -107,6 +107,21 @@ test_expect_success 'test that the directory was renamed' '
 	test dir/D = "$(cat diroh/D.t)"
 '
 
+V=$(git rev-parse HEAD)
+
+test_expect_success 'populate --state-branch' '
+	git filter-branch --state-branch state -f --tree-filter "touch file || :" HEAD
+'
+
+W=$(git rev-parse HEAD)
+
+test_expect_success 'using --state-branch to skip already rewritten commits' '
+	test_when_finished git reset --hard $V &&
+	git reset --hard $V &&
+	git filter-branch --state-branch state -f --tree-filter "touch file || :" HEAD &&
+	test_cmp_rev $W HEAD
+'
+
 git tag oldD HEAD~4
 test_expect_success 'rewrite one branch, keeping a side branch' '
 	git branch modD oldD &&
-- 
2.17.1


^ permalink raw reply related	[flat|nested] 5+ messages in thread

* Re: [PATCH] filter-branch: skip commits present on --state-branch
  2018-06-23  4:36 [PATCH] filter-branch: skip commits present on --state-branch Michael Barabanov
@ 2018-06-25 22:14 ` Junio C Hamano
  2018-06-26  4:07 ` [PATCH v2] " Michael Barabanov
  1 sibling, 0 replies; 5+ messages in thread
From: Junio C Hamano @ 2018-06-25 22:14 UTC (permalink / raw)
  To: Michael Barabanov; +Cc: git, ijc

Michael Barabanov <michael.barabanov@gmail.com> writes:

> The commits in state:filter.map have already been processed, so don't
> filter them again. This makes incremental git filter-branch much faster.
>
> Also add tests for --state-branch option.
>
> Signed-off-by: Michael Barabanov <michael.barabanov@gmail.com>
> ---
>  git-filter-branch.sh     |  3 +++
>  t/t7003-filter-branch.sh | 15 +++++++++++++++
>  2 files changed, 18 insertions(+)
>
> diff --git a/git-filter-branch.sh b/git-filter-branch.sh
> index ccceaf19a..2df7ed107 100755
> --- a/git-filter-branch.sh
> +++ b/git-filter-branch.sh
> @@ -372,6 +372,9 @@ while read commit parents; do
>  	git_filter_branch__commit_count=$(($git_filter_branch__commit_count+1))
>  
>  	report_progress
> +	if test -r "$workdir/../map/$commit"; then
> +		continue
> +	fi

The original script is so much of a mess that I needed quite some
time to find enough evidence to convince myself that this change is
in line with what is already happening in the program.  We have

	test -f "$workdir"/../map/$sha1 && continue

in the codepath for remap-to-ancestor prostprocessing to do
pretty-much the same skipping.

I think the new code should follow suit, i.e.

	if test -f "$workdir/../map/$commit"
	then
		continue
	fi

to check just the existence for consistency.

It would have been reviewer friendly if the proposed commit log
message said how this change does *not* break the progress output
and count.  A possible alternative optimization could be not to add
these already mapped commits in ../revs file in the first place (so
they are not even counted as part of $commits), and such a change
would give different meaning to the progress output (which may or
may not be a good change).  Instead, the posted patch counts the
commits to be filtered the same way as before, and merely pretends
that it filtered those commits to their mapped counterparts without
spending any cycle (simply because we already _know_ what they are
mapped to), so the meaning of the numbers in the progress display
does not change at all---just they appear to progress much faster,
which is a welcome change ;-)




^ permalink raw reply	[flat|nested] 5+ messages in thread

* [PATCH v2] filter-branch: skip commits present on --state-branch
  2018-06-23  4:36 [PATCH] filter-branch: skip commits present on --state-branch Michael Barabanov
  2018-06-25 22:14 ` Junio C Hamano
@ 2018-06-26  4:07 ` Michael Barabanov
  2018-06-26 18:58   ` Ian Campbell
  1 sibling, 1 reply; 5+ messages in thread
From: Michael Barabanov @ 2018-06-26  4:07 UTC (permalink / raw)
  To: gitster; +Cc: git, ijc, Michael Barabanov

The commits in state:filter.map have already been processed, so don't
filter them again. This makes incremental git filter-branch much faster.

Also add tests for --state-branch option.

Signed-off-by: Michael Barabanov <michael.barabanov@gmail.com>
---
 git-filter-branch.sh     |  1 +
 t/t7003-filter-branch.sh | 15 +++++++++++++++
 2 files changed, 16 insertions(+)

diff --git a/git-filter-branch.sh b/git-filter-branch.sh
index ccceaf19a..5c5afa2b9 100755
--- a/git-filter-branch.sh
+++ b/git-filter-branch.sh
@@ -372,6 +372,7 @@ while read commit parents; do
 	git_filter_branch__commit_count=$(($git_filter_branch__commit_count+1))
 
 	report_progress
+	test -f "$workdir"/../map/$commit && continue
 
 	case "$filter_subdir" in
 	"")
diff --git a/t/t7003-filter-branch.sh b/t/t7003-filter-branch.sh
index ec4b160dd..e23de7d0b 100755
--- a/t/t7003-filter-branch.sh
+++ b/t/t7003-filter-branch.sh
@@ -107,6 +107,21 @@ test_expect_success 'test that the directory was renamed' '
 	test dir/D = "$(cat diroh/D.t)"
 '
 
+V=$(git rev-parse HEAD)
+
+test_expect_success 'populate --state-branch' '
+	git filter-branch --state-branch state -f --tree-filter "touch file || :" HEAD
+'
+
+W=$(git rev-parse HEAD)
+
+test_expect_success 'using --state-branch to skip already rewritten commits' '
+	test_when_finished git reset --hard $V &&
+	git reset --hard $V &&
+	git filter-branch --state-branch state -f --tree-filter "touch file || :" HEAD &&
+	test_cmp_rev $W HEAD
+'
+
 git tag oldD HEAD~4
 test_expect_success 'rewrite one branch, keeping a side branch' '
 	git branch modD oldD &&
-- 
2.18.0


^ permalink raw reply related	[flat|nested] 5+ messages in thread

* Re: [PATCH v2] filter-branch: skip commits present on --state-branch
  2018-06-26  4:07 ` [PATCH v2] " Michael Barabanov
@ 2018-06-26 18:58   ` Ian Campbell
  2018-06-26 22:44     ` Junio C Hamano
  0 siblings, 1 reply; 5+ messages in thread
From: Ian Campbell @ 2018-06-26 18:58 UTC (permalink / raw)
  To: Michael Barabanov, gitster; +Cc: git

On Mon, 2018-06-25 at 21:07 -0700, Michael Barabanov wrote:
> The commits in state:filter.map have already been processed, so don't
> filter them again. This makes incremental git filter-branch much
> faster.
> 
> Also add tests for --state-branch option.
> 
> Signed-off-by: Michael Barabanov <michael.barabanov@gmail.com>

Acked-by: Ian Campbell <ijc@hellion.org.uk>

> ---
>  git-filter-branch.sh     |  1 +
>  t/t7003-filter-branch.sh | 15 +++++++++++++++
>  2 files changed, 16 insertions(+)
> 
> diff --git a/git-filter-branch.sh b/git-filter-branch.sh
> index ccceaf19a..5c5afa2b9 100755
> --- a/git-filter-branch.sh
> +++ b/git-filter-branch.sh
> @@ -372,6 +372,7 @@ while read commit parents; do
>  	git_filter_branch__commit_count=$(($git_filter_branch__commi
> t_count+1))
>  
>  	report_progress
> +	test -f "$workdir"/../map/$commit && continue
>  
>  	case "$filter_subdir" in
>  	"")
> diff --git a/t/t7003-filter-branch.sh b/t/t7003-filter-branch.sh
> index ec4b160dd..e23de7d0b 100755
> --- a/t/t7003-filter-branch.sh
> +++ b/t/t7003-filter-branch.sh
> @@ -107,6 +107,21 @@ test_expect_success 'test that the directory was
> renamed' '
>  	test dir/D = "$(cat diroh/D.t)"
>  '
>  
> +V=$(git rev-parse HEAD)
> +
> +test_expect_success 'populate --state-branch' '
> +	git filter-branch --state-branch state -f --tree-filter
> "touch file || :" HEAD
> +'
> +
> +W=$(git rev-parse HEAD)
> +
> +test_expect_success 'using --state-branch to skip already rewritten
> commits' '
> +	test_when_finished git reset --hard $V &&
> +	git reset --hard $V &&
> +	git filter-branch --state-branch state -f --tree-filter
> "touch file || :" HEAD &&
> +	test_cmp_rev $W HEAD
> +'
> +
>  git tag oldD HEAD~4
>  test_expect_success 'rewrite one branch, keeping a side branch' '
>  	git branch modD oldD &&

^ permalink raw reply	[flat|nested] 5+ messages in thread

* Re: [PATCH v2] filter-branch: skip commits present on --state-branch
  2018-06-26 18:58   ` Ian Campbell
@ 2018-06-26 22:44     ` Junio C Hamano
  0 siblings, 0 replies; 5+ messages in thread
From: Junio C Hamano @ 2018-06-26 22:44 UTC (permalink / raw)
  To: Ian Campbell; +Cc: Michael Barabanov, git

Ian Campbell <ijc@hellion.org.uk> writes:

> On Mon, 2018-06-25 at 21:07 -0700, Michael Barabanov wrote:
>> The commits in state:filter.map have already been processed, so don't
>> filter them again. This makes incremental git filter-branch much
>> faster.
>> 
>> Also add tests for --state-branch option.
>> 
>> Signed-off-by: Michael Barabanov <michael.barabanov@gmail.com>
>
> Acked-by: Ian Campbell <ijc@hellion.org.uk>

Thanks.

>
>> ---
>>  git-filter-branch.sh     |  1 +
>>  t/t7003-filter-branch.sh | 15 +++++++++++++++
>>  2 files changed, 16 insertions(+)
>> 
>> diff --git a/git-filter-branch.sh b/git-filter-branch.sh
>> index ccceaf19a..5c5afa2b9 100755
>> --- a/git-filter-branch.sh
>> +++ b/git-filter-branch.sh
>> @@ -372,6 +372,7 @@ while read commit parents; do
>>  	git_filter_branch__commit_count=$(($git_filter_branch__commi
>> t_count+1))
>>  
>>  	report_progress
>> +	test -f "$workdir"/../map/$commit && continue
>>  
>>  	case "$filter_subdir" in
>>  	"")
>> diff --git a/t/t7003-filter-branch.sh b/t/t7003-filter-branch.sh
>> index ec4b160dd..e23de7d0b 100755
>> --- a/t/t7003-filter-branch.sh
>> +++ b/t/t7003-filter-branch.sh
>> @@ -107,6 +107,21 @@ test_expect_success 'test that the directory was
>> renamed' '
>>  	test dir/D = "$(cat diroh/D.t)"
>>  '
>>  
>> +V=$(git rev-parse HEAD)
>> +
>> +test_expect_success 'populate --state-branch' '
>> +	git filter-branch --state-branch state -f --tree-filter
>> "touch file || :" HEAD
>> +'
>> +
>> +W=$(git rev-parse HEAD)
>> +
>> +test_expect_success 'using --state-branch to skip already rewritten
>> commits' '
>> +	test_when_finished git reset --hard $V &&
>> +	git reset --hard $V &&
>> +	git filter-branch --state-branch state -f --tree-filter
>> "touch file || :" HEAD &&
>> +	test_cmp_rev $W HEAD
>> +'
>> +
>>  git tag oldD HEAD~4
>>  test_expect_success 'rewrite one branch, keeping a side branch' '
>>  	git branch modD oldD &&

^ permalink raw reply	[flat|nested] 5+ messages in thread

end of thread, other threads:[~2018-06-26 22:44 UTC | newest]

Thread overview: 5+ messages (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2018-06-23  4:36 [PATCH] filter-branch: skip commits present on --state-branch Michael Barabanov
2018-06-25 22:14 ` Junio C Hamano
2018-06-26  4:07 ` [PATCH v2] " Michael Barabanov
2018-06-26 18:58   ` Ian Campbell
2018-06-26 22:44     ` Junio C Hamano

Code repositories for project(s) associated with this public inbox

	https://80x24.org/mirrors/git.git

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).